import 'package:flutter/material.dart';

import '../routing.dart';
import '../widgets/fade_transition_page.dart';

abstract class BlessingScaffoldBody extends StatelessWidget {
  static GlobalKey<NavigatorState> navigatorKey = GlobalKey<NavigatorState>();

  const BlessingScaffoldBody({
    super.key,
  });

  @override
  Widget build(BuildContext context) {
    var currentRoute = RouteStateScope.of(context).route;
    var page = getPage(currentRoute);

    page ??= FadeTransitionPage<void>(
        key: const ValueKey('empty'), child: Container());

    return Navigator(
      key: navigatorKey,
      onPopPage: (route, dynamic result) => route.didPop(result),
      pages: [page],
    );
  }

  FadeTransitionPage? getPage(ParsedRoute currentRoute);
}
